SystemOrganization addCategory: #ConfigurationOfTeapot!

Object subclass: #ConfigurationOfTeapot
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfTeapot'!

!ConfigurationOfTeapot class methodsFor: 'development support' stamp: 'AttilaMagyar 8/24/2014 18:38'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfTeapot class methodsFor: 'private' stamp: 'AttilaMagyar 8/24/2014 18:38'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfTeapot class methodsFor: 'private' stamp: 'AttilaMagyar 8/24/2014 18:38'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfTeapot class methodsFor: 'private' stamp: 'AttilaMagyar 8/24/2014 18:38'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfTeapot class methodsFor: 'metacello tool support' stamp: 'AttilaMagyar 8/24/2014 18:38'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfTeapot class methodsFor: 'loading' stamp: 'AttilaMagyar 8/24/2014 18:38'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfTeapot class methodsFor: 'loading' stamp: 'AttilaMagyar 8/24/2014 18:38'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfTeapot class methodsFor: 'loading' stamp: 'AttilaMagyar 8/24/2014 18:38'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfTeapot class methodsFor: 'accessing' stamp: 'AttilaMagyar 8/24/2014 18:38'!
project

	^self new project! !

!ConfigurationOfTeapot class methodsFor: 'development support' stamp: 'AttilaMagyar 8/24/2014 18:38'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfTeapot methodsFor: 'baselines' stamp: 'AttilaMagyar 8/24/2014 18:40'!
baseline01: spec
	<version: '0.1-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://smalltalkhub.com/mc/zeroflag/Teapot/main/'.
		spec package: 'Teapot-Core'. ].
! !

!ConfigurationOfTeapot methodsFor: 'accessing' stamp: 'AttilaMagyar 8/24/2014 18:38'!
customProjectAttributes
	 "Edit to return a collection of any custom attributes e.g. for conditional loading: Array with: #'Condition1' with: #'Condition2.
	For more information see: http://code.google.com/p/metacello/wiki/CustomProjectAttrributes"

	^ #().! !

!ConfigurationOfTeapot methodsFor: 'symbolic versions' stamp: 'AttilaMagyar 8/24/2014 18:38'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '0.1-baseline'.
! !

!ConfigurationOfTeapot methodsFor: 'accessing' stamp: 'AttilaMagyar 8/24/2014 18:38'!
project

	^ project ifNil: [ 
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		project := MetacelloMCProject new projectAttributes: self customProjectAttributes. 
		(Smalltalk at: #MetacelloVersionConstructor) on: self project: project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfTeapot methodsFor: 'symbolic versions' stamp: 'AttilaMagyar 8/24/2014 20:01'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'common' version: '0.8'.
! !

!ConfigurationOfTeapot methodsFor: 'versions' stamp: 'AttilaMagyar 8/24/2014 20:01'!
version08: spec
	<version: '0.8' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'stable'.
		spec description: 'version 0.8'.
		spec author: 'AttilaMagyar'.
		spec timestamp: '8/24/2014 20:01'.
		spec package: 'Teapot-Core' with: 'Teapot-Core-AttilaMagyar.52'. ].
! !
